function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function setupInitialRegion() {
        $.map.removeEventListener("postlayout", setupInitialRegion);
        annotations = _.map(mapData.data.listings, function(listing) {
            return createAnnotation({
                latitude: listing.lat,
                longitude: listing.lng
            });
        });
        $.map.camera = tiMap.createCamera({
            centerCoordinate: {
                latitude: annotations[0].latitude,
                longitude: annotations[0].longitude
            },
            altitude: 150
        });
        $.map.annotations = annotations;
    }
    function createAnnotation(options) {
        var annotation, latitude = options.latitude, longitude = options.longitude;
        annotation = tiMap.createAnnotation({
            latitude: latitude,
            longitude: longitude,
            title: "test"
        });
        return annotation;
    }
    function mapClick(event) {
        var latitude = event.annotation.latitude, longitude = event.annotation.longitude;
        _.defer(function() {
            $.map.camera.centerCoordinate = {
                latitude: latitude,
                longitude: longitude
            };
        });
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "testMapCamera";
    if (arguments[0]) {
        __processArg(arguments[0], "__parentSymbol");
        __processArg(arguments[0], "$model");
        __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __alloyId0 = [];
    $.__views.map = require("ti.map").createView({
        annotations: __alloyId0,
        id: "map",
        left: "0",
        top: "0",
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        enableZoomControls: "false",
        animate: "true",
        userLocation: "false",
        rotateEnabled: "false"
    });
    $.__views.map && $.addTopLevelView($.__views.map);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var tiMap = require("ti.map");
    var mapData = require("testMapCameraAnnotations");
    var annotations = [];
    (function() {})();
    $.map.addEventListener("postlayout", setupInitialRegion);
    $.map.addEventListener("click", mapClick);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;