var tiMap = require('ti.map');
var mapData = require('testMapCameraAnnotations');

var zoomFactor = 2;
var annotations = [];

(function () {
  
}());

// Setting up the Initial Map Region
function setupInitialRegion() {
  $.map.removeEventListener('postlayout', setupInitialRegion);

  // Generating Annotations from Listing Data: Normally we'll use a backbone
  // sync for this
  annotations = _.map(mapData.data.listings, function (listing) {
    return createAnnotation({
        latitude: listing.lat,
        longitude: listing.lng
      });
    });

  // Setting up the camera
  $.map.camera = tiMap.createCamera({
    centerCoordinate: {
      latitude: annotations[0].latitude,
      longitude: annotations[0].longitude
    },
    altitude: 150
  });

  // Adding Annotations to the Map
  $.map.annotations = annotations;
}

// Postlayout Event Listener
$.map.addEventListener('postlayout', setupInitialRegion);

// Creating Annotations
function createAnnotation(options) {
  var annotation,
      latitude = options.latitude,
      longitude = options.longitude;

  annotation = tiMap.createAnnotation({
    latitude: latitude,
    longitude: longitude,
    title: 'test', // Property must be set to get click event.
  });

  return annotation;
}

// Map Click Event Handler
function mapClick(event) {
  var latitude = event.annotation.latitude,
      longitude = event.annotation.longitude;

  // if (! event.annotation.listings) {
  //   return;
  // }

  _.defer(function () {
    $.map.camera.centerCoordinate = {

      // Adjust the camera so that the annotation is right under the popup

      latitude: latitude,

      longitude: longitude
    };
  });
}

// Map Click Event Listener
$.map.addEventListener('click', mapClick);